#define __IOM volatile
#define __IM  volatile
#define __IO  volatile
#define uint32_t unsigned int
#define  int32_t   signed int

#define NOP __no_operation()

#define RCC_PER2_CLOCK_EEPROMEN_Pos     (3U)
#define RCC_PER2_CLOCK_EEPROMEN_Msk     (0x1U << RCC_PER2_CLOCK_EEPROMEN_Pos)   /*!< 0x00000008 */
#define RCC_PER2_CLOCK_EEPROMEN         RCC_PER2_CLOCK_EEPROMEN_Msk

typedef struct {
  __IO uint32_t BKP_WPR;
  __IO uint32_t BKP_LDO;
  __IO uint32_t BKP_CLK;
  __IO uint32_t BKP_RTC;
  __IO uint32_t RTC_WUTR;
  __IO uint32_t RTC_PREDIV;
  __IO uint32_t RTC_PRL;
  __IO uint32_t RTC_ALRM;
  __IO uint32_t RTC_CS;
  __IO uint32_t RTC_TR;
  __IO uint32_t RTC_DR;
  __IO uint32_t RTC_ALRMAR;
  __IO uint32_t RTC_ALRMBR;
  __IO uint32_t RTC_TSTR1;
  __IO uint32_t RTC_TSTR2;
  __IO uint32_t RTC_TSTR3;
  __IO uint32_t RTC_TSDR1;
  __IO uint32_t RTC_TSDR2;
  __IO uint32_t RTC_TSDR3;
  __IO uint32_t RTC_TAFCR;
  __IO uint32_t BKP_TRIM1;
  __IO uint32_t BKP_TRIM2;
  __IO uint32_t BKP_TRIM3;
} BKP_TypeDef;

typedef struct {
  __IO uint32_t CLOCK_STATUS;
  __IO uint32_t PLL_CONTROL;
  __IO uint32_t HS_CONTROL;
  __IO uint32_t CPU_CLOCK;
  __IO uint32_t PER1_CLOCK;
  __IO uint32_t ADC_CLOCK;
  __IO uint32_t RTC_CLOCK;
  __IO uint32_t PER2_CLOCK;
  __IO uint32_t DMA_DONE;
  __IO uint32_t TIM_CLOCK;
  __IO uint32_t UART_CLOCK;
  __IO uint32_t SSP_CLOCK;
  __IO uint32_t RISC_MTIME_DIV;
} RST_CLK_TypeDef;

typedef struct {
  __IO uint32_t CMD;
  __IO uint32_t ADR;
  __IO uint32_t DI;
  __IO uint32_t DO;
  __IO uint32_t KEY;
  __IO uint32_t CTRL;
  __IO uint32_t FUSE_CTRL;
  __IO uint32_t FUSE_KEY;

} EEPROM_TypeDef;

#define BKP_MEM (((volatile unsigned long *) 0x50061000))

#define FLASH_BASE            0x10000000
#define BOOT_BASE             0x00020000

//#define SPI1_BASE             0x50000000
//#define UART1_BASE            0x50008000
//#define UART2_BASE            0x50010000
#define EEPROM_BASE           0x50018000
#define RST_CLK_BASE          0x50020000
//#define DMA_BASE              0x50028000
//#define I2C_BASE              0x50030000
//#define UART3_BASE            0x50038000
//#define ADC_BASE              0x50040000
//#define WWDG_BASE             0x50048000
//#define IWDG_BASE             0x50050000
//#define POWER_BASE            0x50058000
#define BKP_BASE              0x50060000
//#define ADCIU_BASE            0x50068000
//#define TIMER1_BASE           0x50070000
//#define TIMER2_BASE           0x50078000
//#define PORTA_BASE            0x50080000
//#define PORTB_BASE            0x50088000
//#define PORTC_BASE            0x50090000
//#define CRC_BASE              0x50098000
//#define RANDOM_BASE           0x500B8000
//#define ISO7816_BASE          0x500C0000
//#define SPI2_BASE             0x500C8000
//#define SPI3_BASE             0x500D0000
//#define TIMER3_BASE           0x500D8000
//#define TIMER4_BASE           0x500E0000
//#define UART4_BASE            0x500E8000
//#define PORTD_BASE            0x500F0000

//#define SPI1                  ((SPI_TypeDef           *)SPI1_BASE         )
//#define UART1                 ((UART_TypeDef          *)UART1_BASE        )
//#define UART2                 ((UART_TypeDef          *)UART2_BASE        )
#define EEPROM                ((EEPROM_TypeDef        *)EEPROM_BASE       )
#define RST_CLK               ((RST_CLK_TypeDef       *)RST_CLK_BASE      )
//#define DMA                   ((DMA_TypeDef           *)DMA_BASE          )
//#define I2C                   ((I2C_TypeDef           *)I2C_BASE          )
//#define UART3                 ((UART_TypeDef          *)UART3_BASE        )
//#define ADC                   ((ADC_TypeDef           *)ADC_BASE          )
//#define WWDG                  ((WWDG_TypeDef          *)WWDG_BASE         )
//#define IWDG                  ((IWDG_TypeDef          *)IWDG_BASE         )
//#define POWER                 ((POWER_TypeDef         *)POWER_BASE        )
#define BKP                   ((BKP_TypeDef           *)BKP_BASE          )
//#define ADCIU                 ((ADCIU_TypeDef         *)ADCIU_BASE        )
//#define TIMER1                ((TIMER_TypeDef         *)TIMER1_BASE       )
//#define TIMER2                ((TIMER_TypeDef         *)TIMER2_BASE       )
//#define PORTA                 ((PORT_TypeDef          *)PORTA_BASE        )
//#define PORTB                 ((PORT_TypeDef          *)PORTB_BASE        )
//#define PORTC                 ((PORT_TypeDef          *)PORTC_BASE        )
//#define CRC                   ((CRC_TypeDef           *)CRC_BASE          )
//#define RANDOM                ((RANDOM_TypeDef        *)RANDOM_BASE       )
//#define USART                 ((USART_TypeDef         *)ISO7816_BASE      )
//#define SPI2                  ((SPI_TypeDef           *)SPI2_BASE         )
//#define SPI3                  ((SPI_TypeDef           *)SPI3_BASE         )
//#define TIMER3                ((TIMER_TypeDef         *)TIMER3_BASE       )
//#define TIMER4                ((TIMER_TypeDef         *)TIMER4_BASE       )
//#define UART4                 ((UART_TypeDef          *)UART4_BASE        )
//#define PORTD                 ((PORT_TypeDef          *)PORTD_BASE        )

#define EEPROM_Num_NVR_Sectors          16
#define EEPROM_Words_per_NVR_Sector     128

#define MLDR215_EEPROM_Num_Sectors        512
#define MLDR215_EEPROM_Words_per_Sector   128


#define MLDR217_EEPROM_Words_Info_Sector  2048
#define MLDR217_EEPROM_Num_Info_Sectors   2
#define MLDR217_EEPROM_Num_Main_Sectors   64
#define MLDR217_EEPROM_Words_per_Sector   1024


#define EEPROM_CTRL_BYTE_S              0

#define EEPROM_CMD_CON_S                0
#define EEPROM_CMD_CE_S                 6
#define EEPROM_CMD_WE_S                 7
#define EEPROM_CMD_NVR_S                9
#define EEPROM_CMD_ERASE_S              10
#define EEPROM_CMD_CHIP_S               11
#define EEPROM_CMD_PROG_S               12
#define EEPROM_CMD_PROG2_S              13
#define EEPROM_CMD_TMEN_S               14

#define EEPROM_CMD_CON_ENABLE           1<<EEPROM_CMD_CON_S
#define EEPROM_CMD_CON_DISABLE          0<<EEPROM_CMD_CON_S
#define EEPROM_CMD_TMEN_ENABLE          0<<EEPROM_CMD_TMEN_S
#define EEPROM_CMD_TMEN_DISABLE         1<<EEPROM_CMD_TMEN_S

#define EEPROM_Mass_Erase               1
#define EEPROM_Sector_Erase             0

#define EEPROM_Access_Disable           ((uint32_t)0x00000000)  /*!< EEPROM Access disable */
#define EEPROM_Access_Enable            ((uint32_t)0x8AAA5551)  /*!< EEPROM Access enable */
#define EEPROM_Main_Bank_Select         ((uint32_t)0x00000000)  /*!< EEPROM Main Bank Selector */
#define EEPROM_Info_Bank_Select         ((uint32_t)0x00000001)  /*!< EEPROM Information Bank Selector */

#define MLDR215_FLASH_TERASE_MASS       35000 // 30000 .. 40000
#define MLDR215_FLASH_TERASE_SECT        2500 // 2000 .. 3000
#define MLDR215_FLASH_TNVS_CHIP_ERASE   80
#define MLDR215_FLASH_TNVS_SECT_ERASE   20
#define MLDR215_FLASH_TNVS_PROG         20
#define MLDR215_FLASH_TPROG             6 // 5 .. 6.5
#define MLDR215_FLASH_TPGS              60 // 50..70
#define MLDR215_FLASH_TRCV_CHIP_ERASE   200
#define MLDR215_FLASH_TRCV_SECT_ERASE   50
#define MLDR215_FLASH_TRCV_PROG         50
#define MLDR215_FLASH_TRW1              1 // 0.5..
#define MLDR215_FLASH_TRW2              10


#define CORE_FREQ 8000000ul

